# std::fgetc, std::getc

From cppreference.com
< cpp‎ | io‎ | c

Defined in header `<cstdio>` |  |
int fgetc( std::FILE* stream ); int getc( std::FILE* stream ); |  |

Reads the next character from the given input stream.

### Parameters

stream | - | to read the character from

### Return value

The obtained character on success or EOF on failure.

If the failure has been caused by end of file condition, additionally sets the eof indicator (see std::feof()) on `stream`. If the failure has been caused by some other error, sets the error indicator (see std::ferror()) on `stream`.

### Example

Run this code

    #include <cstdio>
    #include <cstdlib>

    int main()
    {
        FILE* fp = std::fopen("test.txt", "r");
        if(!fp) {
            std::perror("File opening failed");
            return EXIT_FAILURE;
        }

        int c; // note: int, not char, required to handle EOF
        while ((c = std::fgetc(fp)) != EOF) { // standard C I/O file reading loop
           std::putchar(c);
        }

        if (std::ferror(fp))
            std::puts("I/O error when reading");
        else if (std::feof(fp))
            std::puts("End of file reached successfully");

        std::fclose(fp);
    }

### See also

gets (until C++14) | reads a character string from stdin (function)
fputc putc | writes a character to a file stream (function)
ungetc | puts a character back into a file stream (function)
C documentation for fgetc, getc

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/io/c/fgetc&oldid=73483"